#!/usr/bin/env python3
#Reconfiguration program
#This re-runs the configuration for Marcus's Mupen64Plus launcher
#regardless of the value of the "initial" variable in initial.py

from easygui import *
import os

ver = "Marcus's Mupen64Plus Launcher 15.10.26"

#Configures the Mupen64 install directory
msg = "We need to know where Mupen64Plus is installed to.  In the next dialog, please select the folder where we can find the mupen64plus executable.  You can exit at any time by clicking the Cancel button."
if ccbox( msg=msg, title=ver ):
	pass
else:
	exit(0)
gamedir = diropenbox( "Select the folder where you have Mupen64Plus installed", default=os.environ['HOME'] )
if gamedir:
	pass
else:
	exit(0)

#Configures the ROMs directory
msg = "We need to know where you keep your N64 ROMs.  In the next dialog, select the folder where you store your ROMs."
if ccbox( msg=msg, title=ver ):
	pass
else:
	exit(0)
romdir = diropenbox( title="Select the folder where you keep your ROMs", default=os.environ['HOME'] )
if romdir:
	pass
else:
	exit(0)

#Configures the screen resolution and whether to run full screen
#or windowed
msg = "What resolution would like to run your games at?\nExample: 1024x768"
res = enterbox( msg=msg, title=ver )
if res:
	pass
else:
	exit(0)

msg = "Fullscreen or windowed mode?"
size = indexbox( msg=msg, title=ver, choices=( 'Fullscreen', 'Windowed', 'Cancel' ) )
if size == 0:
	size = "fullscreen"
if size == 1:
	size = "windowed"
if size == 2:
	exit(0)
	
#Requests which graphics engine to use
msg = "Which video plugin would you like to use?  If you are unsure, then try one out and see how it works.  If you want to point to a specific plugin file, click 'Custom' and point to the plugin file.  If you don't like it, you can always run the 'reconfigure.py' program to pick a different one."
gfx = indexbox( msg=msg, title=ver, choices=( 'Glide64MK2', 'Rice Video', 'Custom', 'Cancel' ) )
if gfx == 0:
	gfx = "mupen64plus-video-glide64mk2.so"
if gfx == 1:
	gfx = "mupen64plus-video-rice.so"
if gfx == 2:
	gfx = fileopenbox( title="Select the graphics plugin to use", default="%s/"%( gamedir ), filetypes = ["*.so"], )
	if gfx:
		pass
	else:
		exit(0)
if size == 3:
	exit(0)

#Writes all of the information gathered to a config file
msg = "You have entered the following settings:\n\nMupen64Plus Install Folder: %s\n\nN64 ROMs Folder: %s\n\nResolution: %s\n\nScreen Type: %s\n\nVideo Plugin: %s\n\nTo accept these values just click Continue.  If you want to change any of these settings at a later date, for example if you get a different screen and need to change the resolution, you can either run the 'reconfigure.py' program, or you can open the 'config.py' file yourself and edit the settings there."%( gamedir, romdir, res, size, gfx )
summary = indexbox( msg=msg, title=ver, choices=( 'Continue', 'Cancel' ) )
if summary == 0:
	pass
else:
	exit(0)
	
#Writes everything to the config file
commit = open("config.py", "w")
commit.write( "#This is just a file for storing the configuration of the program.\n\n" )
commit.write( "#Marcus Dean Adams (marcusdean.adams@gmail.com\n#All variable values should be contained in quotes\n\n" )
commit.write( "#Screen Resolution\n\n#Values should be entered in the following format: WidthxHeight\n#Example: 1024x768\nres = '%s'\n\n"%(res) )
commit.write( "#ROMs Folder\n\n#There's no need to add a backslash to the end of this path\nromdir = '%s'\n\n"%(romdir) )
commit.write( "#Mupen64Plus Directory\n\n#There's no need to add a backslash to the end of this path\ngamedir = '%s'\n\n"%(gamedir) )
commit.write( "#Screen type\n\n#Valid values are \"fullscreen\" and \"windowed\", must be all lowercase.\nscreentype = '%s'\n\n"%(size))
commit.write( "#Video plugin\n\n#The filename of the video plugin file.  If you wish to use a plugin\n#that is not located in the Mupen64Plus install directory, you must\n#specify the full path to the plugin file.\ngfx = '%s'\n"%(gfx) )
commit.close()

commit = open( 'initial.py', 'w' )
commit.write( "#The whole purpose of this is to determine whether or not the\n" )
commit.write( "#initial configuration has been run.\n\n" )
commit.write( "initial = 'true' " )
commit.close()

exit(0)
